$title	QTool Solution Program  (QS.GMS)

$if not set model $set model model
$if not set outdir $set outdir output\

$if not set p1 $abort "Input parameter P1 must be defined as an environment variable." 

SETS
$if set p1	p1	%p1%
$if set p2	p2	%p2%
$if set p3	p3	%p3%
$if set p4	p4	%p4%
$if set p5	p5	%p5%
$if set p6	p6	%p6%
;


file kbat /%outdir%rungams.bat/; kbat.lw=0; kbat.nd=0; kbat.nw=0; kbat.tw=0; put kbat,'@echo off'/'if not exist %outdir%nul mkdir %outdir%'/;
file kinc /%outdir%qr.inc/;
scalar id /0/, nrun;

*	Branch to the appropriate loop depending on the number of items:

$if not defined p2 $goto 1
$if not defined p3 $goto 2
$if not defined p4 $goto 3
$if not defined p5 $goto 4
$if not defined p6 $goto 5
$goto 6

$label 1
$if defined p3	$abort 'Did not expect p3 to be defined if p2 is not defined.'
$if defined p4	$abort 'Did not expect p4 to be defined if p2 is not defined.'
$if defined p5	$abort 'Did not expect p5 to be defined if p2 is not defined.'
$if defined p6	$abort 'Did not expect p6 to be defined if p2 is not defined.'

nrun = card(p1);
loop(p1,
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts/;
$exit

$label 2
$if defined p4	$abort 'Did not expect p4 to be defined if p3 is not defined.'
$if defined p5	$abort 'Did not expect p5 to be defined if p3 is not defined.'
$if defined p6	$abort 'Did not expect p6 to be defined if p3 is not defined.'

nrun = card(p1)*card(p2);
loop((p1,p2),
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"."',p2.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p2.ts,' "',p2.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts,',',p2.ts/;
$exit

$label 3
$if defined p5	$abort 'Did not expect p5 to be defined if p4 is not defined.'
$if defined p6	$abort 'Did not expect p6 to be defined if p4 is not defined.'

nrun = card(p1)*card(p2)*card(p3);
loop((p1,p2,p3),
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"."',p2.tl,'"."',p3.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p2.ts,' "',p2.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p3.ts,' "',p3.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts,',',p2.ts,',',p3.ts/;
$exit

$label 4
$if defined p6	$abort 'Did not expect p6 to be defined if p5 is not defined.'

nrun = card(p1)*card(p2)*card(p3)*card(p4);
loop((p1,p2,p3,p4),
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"."',p2.tl,'"."',p3.tl,'"."',p4.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p2.ts,' "',p2.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p3.ts,' "',p3.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p4.ts,' "',p4.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts,',',p2.ts,',',p3.ts,',',p4.ts/;
$exit

$label 5
nrun = card(p1)*card(p2)*card(p3)*card(p4)*card(p5);
loop((p1,p2,p3,p4,p5),
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"."',p2.tl,'"."',p3.tl,'"."',p4.tl,'"."',p5.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p2.ts,' "',p2.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p3.ts,' "',p3.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p4.ts,' "',p4.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p5.ts,' "',p5.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts,',',p2.ts,',',p3.ts,',',p4.ts,',',p5.ts/;
$exit

$label 6
nrun = card(p1)*card(p2)*card(p3)*card(p4)*card(p5)*card(p6);
loop((p1,p2,p3,p4,p5,p6),
	id = id + 1;
	put 'title Solving case ',id,' out of ',nrun/;
	put 'echo set q_inputs/"',p1.tl,'"."',p2.tl,'"."',p3.tl,'"."',p4.tl,'"."',p5.tl,'"."',p6.tl,'"/;  >%outdir%',id,'.gms'/;
	put 'echo $set ',p1.ts,' "',p1.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p2.ts,' "',p2.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p3.ts,' "',p3.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p4.ts,' "',p4.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p5.ts,' "',p5.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $set ',p6.ts,' "',p6.tl,'" >>%outdir%',id,'.gms'/;
	put 'echo $include %model% >>%outdir%',id,'.gms'/;
	put 'gams %outdir%',id,'.gms gdx=%outdir%',id,' o=%outdir%',id,'.lst'/;
);
putclose;
putclose kinc, '$setglobal inputs ',p1.ts,',',p2.ts,',',p3.ts,',',p4.ts,',',p5.ts,',',p6.ts/;
$exit

